RadialBar = {
    container : undefined,
    barCircle : $("<div id='bar-circle'></div>"),
    archideLeft : $("<div class='archideleft'></div>"),
    archideRight : $("<div class='archideright'></div>"),
    arcLeft : $("<div class='arcleft'></div>"),
    arcRight : $("<div class='arcright'></div>"),
    percentage : $("<p id='percentage'></p>"),
    description : $("<p id='description'></p>"),
    currentPerc : 0,
    diameter: 200,
    speedIndex: 20,
    strokeWidth : "1pt",
    createBar : function()
    {
        this.container = $("#bar-container");
        $(this.container).append(this.barCircle);
        $(this.barCircle).append(this.archideLeft);
        $(this.barCircle).append(this.archideRight);
        $(this.barCircle).append(this.percentage);
        $(this.barCircle).append(this.description);
        $(this.archideLeft).append(this.arcLeft);
        $(this.archideRight).append(this.arcRight);

        //hack to remove margins from stroke
        $(this.barCircle).css({"width": "-=" +parseInt(this.strokeWidth)*2 + "pt",
                               "height": "-=" + parseInt(this.strokeWidth)*2 + "pt"});
        //set zero
        $(this.archideRight).css("height", "0pt");
    },
    set : function(perc, desc)
    {
        this.setPercentage(perc);
        $(this.description).text(desc);
    },
    setPercentage : function(perc)
    {
        var context = this;
        var time = Math.abs(this.currentPerc - perc)*this.speedIndex;
        var time1 = Math.abs(this.currentPerc - 50)*this.speedIndex;
        var time2 = Math.abs(50 - perc)*this.speedIndex;
        var cPerc = this.currentPerc;

        if (this.currentPerc < perc)
            var changePerc = setInterval(function() {
                $(context.percentage).html(cPerc + "<span>%</span>");
                cPerc++;
            },context.speedIndex);
        else var changePerc = setInterval(function() {
            $(context.percentage).html(cPerc + "<span>%</span>");
            cPerc--;
        },context.speedIndex);

        if (perc <= 50) {
            var l = context.diameter / 2 - (context.diameter / 2) * Math.cos((perc * 2 / 100) * 180 * 0.01745);
            if (this.currentPerc > 50) {
                $(this.archideLeft).animate({height: "0pt"}, time1, function () {
                    $(context.archideRight).show();
                    $(context.archideRight).animate({height: l + "pt"},time2, function(){
                        clearInterval(changePerc);
                        $(context.percentage).html(perc + "<span>%</span>")
                    });
                });
            }
            else
            {
                $(this.archideRight).show();
                $(this.archideRight).animate({height: l + "pt"},time, function(){
                        clearInterval(changePerc);
                        $(context.percentage).html(perc + "<span>%</span>")
                });

            }
        }
        else if (this.currentPerc < 50) {
            $(this.archideRight).show();
            $(this.archideRight).animate({height: this.diameter + "pt"}, time1, function(){
                $(context.archideLeft).show();
                var l = context.diameter / 2 - (context.diameter / 2) * Math.cos(((50 - perc)*2 / 100) * 180 * 0.01745);
                $(context.archideLeft).animate({height: l + "pt"}, time2, function(){
                    clearInterval(changePerc);
                    $(context.percentage).html(perc + "<span>%</span>");
                });
            });
        }
        else {
            $(this.archideRight).show();
            var l = this.diameter / 2 - (this.diameter / 2) * Math.cos(((50 - perc)*2 / 100) * 180 * 0.01745);
            $(this.archideLeft).animate({height: l + "pt"},time,function(){
                clearInterval(changePerc);
                $(context.percentage).html(perc + "<span>%</span>");
            });

        }

        this.currentPerc = perc;
    },
    style : function(data)
    {
        for(var key in data) {
            this.setStyle(key, data[key]);
        }
    },
    setStyle : function(name, value)
    {
        switch(name) {
            case "diameter":
                this.diameter = parseInt(value);
                $(this.container).css({"width": value, "height": value});
                $(this.arcLeft).css({"height": value});
                $(this.arcRight).css({"height": value});
                //hack to remove margins from stroke
                $(this.barCircle).removeAttr("style");
                $(this.barCircle).css({"width": "-=" + parseInt(this.strokeWidth)*2 + "pt","height": "-=" + parseInt(this.strokeWidth)*2 + "pt"});
                break;
            case "backgroundColor":
                $(this.barCircle).css({"background-color": value});
                break;
            case "emptyStrokeColor":
                $(this.barCircle).css({"border-color": value});
                break;
            case "fillStrokeColor":
                $(this.arcLeft).css({"border-color": value});
                $(this.arcRight).css({"border-color": value});
                break;
            case "fillStrokeWidth":
                $(this.arcLeft).css({"border-width": value});
                $(this.arcRight).css({"border-width": value});
                break;
            case "percentagesFontSize":
                $(this.percentage).css({"font-size": value});
                break;
            case "percentagesFontColor":
                $(this.percentage).css({"color": value});
                break;
            case "descriptionFontSize":
                $(this.description).css({"font-size": value});
                break;
            case "descriptionFontColor":
                $(this.description).css({"color": value});
                break;
            default:
             return;
        }
    }
}